=== debian/changelog ===
golang-github-crc-org-crc (2.34.0+ds1-2) unstable; urgency=medium

  * Team upload.
  * Make dev package arch all/foreign, not any.
  * Standards-Version: 4.7.0.
  * Fix Vcs-* URLs to renamed git repo.
  * Add salsa-ci.yml.
  * Run wrap-and-sort -at.
  * Remove d/rules whitespace.
  * Drop unnecessary B-D's.
  * Mention my d/* copyright.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 19 Nov 2024 20:05:27 +0100

golang-github-crc-org-crc (2.34.0+ds1-1) unstable; urgency=medium

  * Initial release (Closes: #1067503)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 23 Mar 2024 11:49:49 -0400
