=== debian/control ===
Source: golang-github-crc-org-crc
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Reinhard Tartler <siretart@tauware.de>,
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-sequence-golang,
               golang-any,
               golang-github-alecaivazis-survey-dev,
               golang-github-asaskevich-govalidator-dev,
               golang-github-cavaliergopher-grab-dev,
               golang-github-containers-gvisor-tap-vsocks-dev,
               golang-github-containers-image-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-docker-go-units-dev,
               golang-github-elazarl-goproxy-dev,
               golang-github-gorilla-handlers-dev,
               golang-github-jinzhu-copier-dev,
               golang-github-klauspost-compress-dev,
               golang-github-masterminds-semver-dev,
               golang-github-mattn-go-colorable-dev,
               golang-github-mdlayher-vsock-dev,
               golang-github-onsi-ginkgo-dev,
               golang-github-opencontainers-image-spec-dev,
               golang-github-openshift-api-dev,
               golang-github-pbnjay-memory-dev,
               golang-github-pkg-browser-dev,
               golang-github-pkg-errors-dev,
               golang-github-protonmail-go-crypto-dev,
               golang-github-spf13-cast-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
               golang-github-spf13-viper-dev,
               golang-github-stretchr-testify-dev,
               golang-github-zalando-go-keyring-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sync-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-term-dev,
               golang-gomega-dev,
               golang-gopkg-cheggaaa-pb.v1-dev,
               golang-gopkg-h2non-filetype.v1-dev,
               golang-gopkg-natefinch-lumberjack.v2-dev,
               golang-gopkg-yaml.v3-dev,
               golang-k8s-api-dev,
               golang-k8s-apimachinery-dev,
               golang-k8s-client-go-dev,
               golang-logrus-dev,
               golang-uuid-dev,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-crc-org-crc
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-crc-org-crc.git
Homepage: https://github.com/crc-org/crc
XS-Go-Import-Path: github.com/crc-org/crc

Package: golang-github-crc-org-crc-dev
Architecture: all
Multi-Arch: foreign
Depends: golang-github-alecaivazis-survey-dev,
         golang-github-asaskevich-govalidator-dev,
         golang-github-cavaliergopher-grab-dev,
         golang-github-containers-gvisor-tap-vsocks-dev,
         golang-github-containers-image-dev,
         golang-github-coreos-go-systemd-dev,
         golang-github-docker-go-units-dev,
         golang-github-elazarl-goproxy-dev,
         golang-github-gorilla-handlers-dev,
         golang-github-jinzhu-copier-dev,
         golang-github-klauspost-compress-dev,
         golang-github-masterminds-semver-dev,
         golang-github-mattn-go-colorable-dev,
         golang-github-mdlayher-vsock-dev,
         golang-github-onsi-ginkgo-dev,
         golang-github-opencontainers-image-spec-dev,
         golang-github-openshift-api-dev,
         golang-github-pbnjay-memory-dev,
         golang-github-pkg-browser-dev,
         golang-github-pkg-errors-dev,
         golang-github-protonmail-go-crypto-dev,
         golang-github-spf13-cast-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
         golang-github-spf13-viper-dev,
         golang-github-stretchr-testify-dev,
         golang-github-zalando-go-keyring-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-term-dev,
         golang-gomega-dev,
         golang-gopkg-cheggaaa-pb.v1-dev,
         golang-gopkg-h2non-filetype.v1-dev,
         golang-gopkg-natefinch-lumberjack.v2-dev,
         golang-gopkg-yaml.v3-dev,
         golang-k8s-api-dev,
         golang-k8s-apimachinery-dev,
         golang-k8s-client-go-dev,
         golang-logrus-dev,
         golang-uuid-dev,
         ${misc:Depends},
Description: Helper tool for running containers - development files
 Helper tool for running containers.
 .
 This package provides source code for building applications that embed crc
