=== debian/rules ===
#!/usr/bin/make -f

export BUILDTAGS := build
export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_BUILDPKG := github.com/crc-org/crc/pkg/os/...

%:
	dh $@ --buildsystem=golang

override_dh_auto_build:
	dh_auto_build -v -- -tags "$(BUILDTAGS)"
